---
title: url()
slug: Web/CSS/url()
tags:
  - CSS
  - CSS Function
  - Function
  - Layout
  - Reference
  - Web
  - url()
---
<div>{{CSSRef}}</div>

<p><span class="seoSummary">The <code><strong>url()</strong></code> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/CSS_Functions">function</a> is used to include a file. The parameter is an absolute URL, a relative URL, or a data URI. The <code><strong>url()</strong></code> function can be passed as a parameter of another CSS functions, like the {{cssxref('attr()')}} function. Depending on the property for which it is a value, the resource sought can be an image, font, or a stylesheet. The <code>url()</code> functional notation is the value for the <code>&lt;url&gt;</code> data type.</span></p>

<div class="notecard note">
<p><strong>URI or URL?</strong> There is a difference between a {{Glossary("URI")}} and a {{Glossary("URL")}}. A URI identifies a resource. A URL is a type of URI, and describes the <em>location</em> of a resource. A URI can be either a URL or a name ({{Glossary("URN")}}) of a resource.</p>

<p>In CSS Level 1, the <code>url()</code> functional notation described only true URLs. In CSS Level 2, the definition of <code>url()</code> was extended to describe any URI, whether a URL or a URN. Confusingly, this meant that <code>url()</code> could be used to create a <code>&lt;uri&gt;</code> CSS data type. This change was not only awkward but, debatably, unnecessary, since URNs are almost never used in actual CSS. To alleviate the confusion, CSS Level 3 returned to the narrower, initial definition. Now, <code>url()</code> denotes only true <code>&lt;url&gt;</code>s.</p>
</div>

<pre class="brush: css no-line-numbers notranslate">/* Simple usage */
url(https://example.com/images/myImg.jpg);
url(data:image/png;base64,iRxVB0…);
url(myFont.woff);
url(#IDofSVGpath);

/* associated properties */
background-image: url("https://mdn.mozillademos.org/files/16761/star.gif");
list-style-image: url('../images/bullet.jpg');
content: url("pdficon.jpg");
cursor: url(mycursor.cur);
border-image-source: url(/media/diamonds.png);
src: url('fantasticfont.woff');
offset-path: url(#path);
mask-image: url("masks.svg#mask1");

/* Properties with fallbacks */
cursor: url(pointer.cur), pointer;

/* Associated short-hand properties */
background: url('https://mdn.mozillademos.org/files/16761/star.gif') bottom right repeat-x blue;
border-image: url("/media/diamonds.png") 30 fill / 30px / 30px space;

/* As a parameter in another CSS function */
background-image: cross-fade(20% url(first.png), url(second.png));
mask-image: image(url(mask.png), skyblue, linear-gradient(rgba(0, 0, 0, 1.0), transparent);

/* as part of a non-shorthand multiple value */
content: url(star.svg) url(star.svg) url(star.svg) url(star.svg) url(star.svg);

/* at-rules */
@document url("https://www.example.com/") { ... } {{Experimental_Inline}}
@import url("https://www.example.com/style.css");
@namespace url(http://www.w3.org/1999/xhtml);
</pre>

<p>Relative URLs, if used, are relative to the URL of the stylesheet (not to the URL of the web page).</p>

<p class="task-list-item">The <code><strong>url()</strong></code> function can be included as a value for {{cssxref('background')}}, {{cssxref('background-image')}}, {{cssxref('list-style')}}, {{cssxref('list-style-image')}}, {{cssxref('content')}}, {{cssxref('cursor')}}, {{cssxref('border')}}, {{cssxref('border-image')}}, {{cssxref('border-image-source')}}, {{cssxref('mask')}}, {{cssxref('mask-image')}}, <a href="/en-US/docs/Web/CSS/@font-face/src">src</a> as part of a <a href="/en-US/docs/Web/CSS/@font-face">@font-face</a> block, and <a href="/en-US/docs/Web/CSS/@counter-style/symbols">@counter-style/symbol</a></p>

<h2 id="Syntax">Syntax</h2>

<h3 id="Values">Values</h3>

<dl>
	<dt><code>&lt;string&gt;</code></dt>
	<dd>
	<dl>
		<dt>&lt;url&gt;</dt>
		<dd>A url, which is a relative or absolute address, or pointer, to the web resource to be included, or a data uri, optionally in single or double quotes. Quotes are required if the URL includes parentheses, whitespace, or quotes, unless these characters are escaped, or if the address includes control characters above 0x7e. Double quotes cannot occur inside double quotes and single quotes cannot occur inside single quotes unless escaped. The following are all valid and equivalent:
		<pre class="syntaxbox notranslate">&lt;css_property&gt;: url("https://example.com/image.png")
&lt;css_property&gt;: url('https://example.com/image.png')
&lt;css_property&gt;: url(https://example.com/image.png)</pre>

		<p>If you choose to write the URL without quotes, use a backslash (<code>\</code>) before any parentheses, whitespace characters, single quotes (<code>'</code>) and double quotes (<code>"</code>) that are part of the URL.</p>
		</dd>
		<dt>path</dt>
		<dd>References the ID of an <a href="/en-US/docs/Web/SVG/Tutorial/Basic_Shapes">SVG shape</a> -- <code>circle</code>, <code>ellipse</code>, <code>line</code>, <code>path</code>, <code>polygon</code>, <code>polyline</code>, or <code>rect</code> -- using the shape's geometry as the path.</dd>
	</dl>
	</dd>
	<dt><code style="white-space: nowrap;">&lt;url-modifier&gt;</code> {{Experimental_Inline}}</dt>
	<dd>In the future, the <code>url()</code> function may support specifying a modifier, an identifier or a functional notation, which alters the meaning of the URL string.This is not supported and not fully defined in the specification.</dd>
</dl>

<h3 id="Formal_syntax">Formal syntax</h3>

<pre class="syntaxbox notranslate">url( <a href="/en-US/docs/Web/CSS/string">&lt;string&gt;</a> &lt;url-modifier&gt;* )</pre>

<h2 id="Examples">Examples</h2>

<h3 id="A_url_used_in_the_background_property">A url used in the background property</h3>

<pre class="notranslate">.topbanner {
  background: url("topbanner.png") #00D no-repeat fixed;
}
</pre>

<h3 id="A_url_loading_an_image_as_a_list_bullet">A url loading an image as a list bullet</h3>

<pre class="notranslate">ul {
  list-style: square url(http://www.example.com/redball.png);
}</pre>

<h3 id="Usage_in_the_content_property">Usage in the content property</h3>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;ul&gt;
  &lt;li&gt;Item 1&lt;/li&gt;
  &lt;li&gt;Item 2&lt;/li&gt;
  &lt;li&gt;Item 3&lt;/li&gt;
&lt;/ul&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css highlight[2] notranslate">li::after {
  content: ' - ' url(https://mdn.mozillademos.org/files/16761/star.gif);
}</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("Usage_in_the_content_property", "100%", 110)}}</p>

<h3 id="Using_a_data-uri">Using a data-uri</h3>

<div id="color-value">
<h4 id="HTML_2">HTML</h4>

<pre class="brush: html notranslate">&lt;div class="background"&gt;&lt;/div&gt;</pre>

<h4 id="CSS_2">CSS</h4>

<div class="hidden">
<pre class="brush: css notranslate">.background {
  height: 100vh;
}</pre>
</div>

<pre class="brush: css highlight[6] notranslate">.background {
  background: yellow;
  background: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' width='90' height='45'%3E%3Cpath d='M10 10h60' stroke='%2300F' stroke-width='5'/%3E%3Cpath d='M10 20h60' stroke='%230F0' stroke-width='5'/%3E%3Cpath d='M10 30h60' stroke='red' stroke-width='5'/%3E%3C/svg%3E");
}</pre>
</div>

<p>{{EmbedLiveSample("Using_a_data-uri", "100%", 50)}}</p>

<h3 id="Usage_in_filters">Usage in filters</h3>

<p>When a URL is used as a path for a filter, the URL must be one of the following:</p>

<ol>
	<li>The path to an SVG file with the ID of the filter appended.</li>
	<li>the ID of the filter, if the SVG already exists on the page.</li>
</ol>

<pre class="notranslate">.blur {
  filter: url(my-file.svg#svg-blur); /* the URL of an SVG file used as a filter */
}

.inline-blur {
  filter: url(#svg-blur); /* the ID of an SVG that is embedded in the HTML page */
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('CSS4 Values', '#urls', 'url()')}}</td>
			<td>{{Spec2('CSS4 Values')}}</td>
			<td></td>
		</tr>
		<tr>
			<td>{{SpecName('CSS3 Values', '#urls', 'url()')}}</td>
			<td>{{Spec2('CSS3 Values')}}</td>
			<td>No significant change from CSS Level 2 (Revision 1).</td>
		</tr>
		<tr>
			<td>{{Specname('CSS2.1', 'syndata.html#uri', 'uri()')}}</td>
			<td>{{Spec2('CSS2.1')}}</td>
			<td>No significant change from CSS Level 1.</td>
		</tr>
		<tr>
			<td>{{SpecName('CSS1', '#url', 'url()')}}</td>
			<td>{{Spec2('CSS1')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("css.types.url")}}</div>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{cssxref("&lt;gradient&gt;")}}</li>
	<li>{{cssxref("element()")}}</li>
	<li>{{cssxref("_image","image()")}}</li>
	<li>{{cssxref("image-set","image-set()")}}</li>
	<li>{{cssxref("cross-fade")}}</li>
</ul>
